void draw() {
  background(32);
  if (cP5.window(this).isMouseOver()) {
    cam.setActive(false);
  } else {
    cam.setActive(true);
  }
  drawSubSection();
  int circleSize = 500;
  textFont(myFutura12);
  colorMode(HSB);
  noStroke();
  translate(500, -100, -500);
  for (int i=0; i<numObjects; i++) {
    pushMatrix();
    agent[i].display();
    agent[i].move();
    //    agent[j].position = ;
    popMatrix();
  }
  //  print("\n" + animationCounter);
  if (animationCounter > 1.0) { 
    animationCounter = 1.0;
  }
  if (gravityFlag == true) {
    animationCounter += 1/200.0;
    gravity();
  }
  if (categoryFlag == true) {
    animationCounter = 0;
    wordCountFlag = false; 
    pubDateFlag = false; 
    animationCounter += 1/50.0;
    for (int i=0; i<numObjects; i++) {
      agent[i].currentPosition.lerp(categoryPosition[i], animationCounter);
    }
    textAlign(RIGHT, CENTER);
    if (labelFlag == true) {
      for (int i=0; i<numWords; i++) {
        pushMatrix();
        textFont(myFutura60);
        translate(lowRand-100, i*200, 0); 
        text(words[i], 0, 0);
        popMatrix();
      }
    }
  }
  if (wordCountFlag == true) {
    animationCounter = 0;
    pubDateFlag = false; 
    categoryFlag = false;
    animationCounter += 1/50.0;
    for (int i=0; i<numObjects; i++) {
      agent[i].currentPosition.lerp(wordCountPosition[i], animationCounter);
    }
    textAlign(CENTER, CENTER);
    if (labelFlag == true) {
      pushMatrix();
      textFont(myFutura60);
      text("word count low", 0, 0);
      translate(0, 1500, 0);
      text("word count hi", 0, 0);
      popMatrix();
    }
  }
  if (pubDateFlag == true) {
    animationCounter = 0;
    wordCountFlag = false;
    categoryFlag = false;
    animationCounter += 1/50.0;
    for (int i=0; i<numObjects; i++) {
      agent[i].currentPosition.lerp(pubDatePosition[i], animationCounter);
    }
    textAlign(CENTER, CENTER);
    if (labelFlag == true) {
      pushMatrix();
      textFont(myFutura60);
      text("2014", 0, -210);
      translate(0, 2000, 0);
      text("1945", 0, 0);
      popMatrix();
    }
  }
  if (target == 1) {
    totalMatches = 0;
    animationCounter += 1/50.0;
    for (int i=0; i<numObjects; i++) {
      agent[i].query = queryString;
      agent[i].findQueryMatch();
      totalMatches +=agent[i].matchFactor;
    }
    target = 0;
  }
  cam.beginHUD();
      textAlign(RIGHT, CENTER);
  if (labelFlag == true) {
    pushMatrix();
    translate(width, -50, -200);
    textFont(myFutura40); 
    text("The word " + queryString + " has " + totalMatches + " total matches", 170, -10);
    popMatrix();
  }
  cam.endHUD();

  drawGUI();
}

void gravity() {
  
  for (int i=0; i<numObjects; i+=1) {
    for (int j=i+1; j<numObjects; j+=1) {
      G = 6.674 * pow(10, -9); // normally pow(10, -11), but I chose larger value to make the effect more visible
      PVector.sub(agent[j].currentPosition, agent[i].currentPosition, distance);  // actual distance
      absDistance = abs(distance.mag());

      float massA = pow(agent[i].matchFactor*9, 3.0);  // mass (from radius, cubed)
      float massB = pow(agent[j].matchFactor*9, 3.0);

      PVector.sub(agent[j].currentPosition, agent[i].currentPosition, distanceA);
      PVector.sub(agent[i].currentPosition, agent[j].currentPosition, distanceB);

      //      distanceA.normalize(normDistanceA);
      //      distanceB.normalize(normDistanceB);

      // law of universal gravitation in vector form (wikipedia.org)
      PVector.mult(distanceA, (G * massA * massB), gravVectorA);
      PVector.mult(distanceB, (G * massA * massB), gravVectorB);

      PVector.div(gravVectorA, pow(absDistance, 2), gravityA);
      PVector.div(gravVectorB, pow(absDistance, 2), gravityB);

      agent[i].velocity.add(gravityA);  // add gravitation to velocity
      agent[j].velocity.add(gravityB);
    }
  }
}

